<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Table to excel converter</title>
    <link href="https://www.jqueryscript.net/css/jquerysctipttop.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootswatch/4.2.1/minty/bootstrap.min.css">
    
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- Import pluggin table to excel, please note jquery slim does not work with ajax function-->
    <script src="https://code.jquery.com/jquery-3.3.1.min.js">
    </script>
    <script src="jquery.tableToExcel.js"></script>
</head>

<body>
    <div class="container">
        <h2 style="text-align: center;">Customer Table</h2>
        <table id="user-table" class="table table-bordered table-striped">
            <thead>
            <tr>
              <th>User Id</th>
              <th>Last Name</th>
              <th>First Name</th>
              <th>Phone</th>
              <th>Address</th>
              <th>City</th>
              <th>State</th>
              <th>Postal Code</th>
              <th>Country</th>
              <th>Sale Employee No.</th>
              <th>Credit Limit</th>
            </tr>
            </thead>
          </table>
          <p><button class="btn btn-primary" onclick="$('table').tblToExcel();">Download Excel</p> 
    </div>
    
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://localhost:8080/allCustomers";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    var gCustomerArr = [];
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
      getCustomerData();
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getCustomerData(){
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        dataType: "json",
        success: function(res){
          console.log(res);
          gCustomerArr = res;
          loadDataToTable(gCustomerArr);
        },
        error: function(err){
          console.log(err.response);
        }
        })
    };
    function loadDataToTable(paramUsers){
        var vUserTable = $("#user-table");
        for (var bI =0; bI <paramUsers.length; bI++){
            //thêm dòng mới và gắn vào table
            var bNewRow = $("<tr>").appendTo(vUserTable);
            //thêm các ô, gắn vào dòng trên và điền dữ liệu innerHTML cho từng ô
            $("<td>", {html: paramUsers[bI].id}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].lastName}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].firstName}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].phoneNumber}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].address}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].city}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].state}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].postalCode}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].country}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].salesRepEmployeeNumber}).appendTo(bNewRow);
            $("<td>", {html: paramUsers[bI].creditLimit}).appendTo(bNewRow);
        }
    }
  });
  </script>
  
</html>
